#include "hack.h"
#include "motif.h"


string consensus_site(Motif &mot1){
  
  string ret;
  vector<string> s1=mot1.raw_sites();
  int wide1=mot1.wide();
  int num1=s1.size();
  int i,j,k;
  int num1a,num1c,num1g,num1t;
  for(i=0;i<wide1;i++){
    num1a=num1c=num1g=num1t=0;
    for(j=0;j<num1;j++){
      if(s1[j][i]=='a'||s1[j][i]=='A') num1a+=1;
      if(s1[j][i]=='c'||s1[j][i]=='C') num1c+=1;
      if(s1[j][i]=='g'||s1[j][i]=='G') num1g+=1;
      if(s1[j][i]=='t'||s1[j][i]=='T') num1t+=1;
    }
    if(num1a>num1*0.7) ret+='A';
    else if(num1c>num1*0.7) ret+='C';
    else if(num1g>num1*0.7) ret+='G';
    else if(num1t>num1*0.7) ret+='T';
    else if((num1a+num1t)>num1*0.85) ret+='W';
    else if((num1a+num1c)>num1*0.85) ret+='M';
    else if((num1a+num1g)>num1*0.85) ret+='R';
    else if((num1t+num1c)>num1*0.85) ret+='Y';
    else if((num1t+num1g)>num1*0.85) ret+='K';
    else if((num1c+num1g)>num1*0.85) ret+='S';
    else ret+='-';
  }
  return ret;
}

string consensus_site(double **frac,int first, int last){
  //frac[first->last][4] is fraction of acgt in each site
  string ret;
  int i;
  double num1a,num1c,num1g,num1t;
  for(i=first;i<=last;i++){
    num1a=frac[i][0];
    num1c=frac[i][1];
    num1g=frac[i][2];
    num1t=frac[i][3];
    if(num1a>0.7) ret+='A';
    else if(num1c>0.7) ret+='C';
    else if(num1g>0.7) ret+='G';
    else if(num1t>0.7) ret+='T';
    else if((num1a+num1t)>0.85) ret+='W';
    else if((num1a+num1c)>0.85) ret+='M';
    else if((num1a+num1g)>0.85) ret+='R';
    else if((num1t+num1c)>0.85) ret+='Y';
    else if((num1t+num1g)>0.85) ret+='K';
    else if((num1c+num1g)>0.85) ret+='S';
    else ret+='-';
  }
  return ret;
}

void Consensus(int argc, char *argv[]){

  if(argc<3){
    cerr<<"Usage:  Consensus file.ace mot_num\n";
    exit(0);
  }
  ifstream fin1(argv[1]);
  int num1=str_to_int(argv[2]);
  Motif m1=read_alignace_motif(fin1,num1);
  string s=consensus_site(m1);
  cout<<s<<'\n';
}

void ScoresACE(int argc, char *argv[]){
  
  if(argc<3){
    cerr<<"Usage:  ScoresACE file.ace mot_num\n";
    exit(0);
  }
  ifstream fin(argv[1]);
  int num=str_to_int(argv[2]);

  string s;
  int x=0;
  while (getline(fin,s,'\n')){
    if(s.size()<5) continue;
    if(s.substr(0,5)=="Motif"){
      if(s.size()>=12&&s.substr(0,12)=="Motif number"){
        x=str_to_int(s.substr(13));
      }
      else{
        x=str_to_int(s.substr(6));
      }
      if(x==num){
        break;
      }
    }
  }
  if(x!=num){
    cout<<"No such motif\t"<<argv[1]<<'\t'<<argv[2]<<"\n";
    exit(0);
  }
  double map_score;
  while(getline(fin,s,'\n')){
    if(s.size()<5) continue;
    if(s.substr(0,9)=="MAP Score"||s.substr(0,9)=="Map Score"){
      map_score=str_to_dbl(s.substr(11));
    }
    if(s.substr(0,5)=="Motif") break;
  }
  cout<<map_score<<'\n';
}
