//Copyright 1998 President and Fellows of Harvard University
//genome.h

#ifndef _genome
#define _genome
#include "standard.h"
#include "orfs.h"
#include "sites.h"

class Genome:public Orfs,public Sites{
  //	vector<string> sequence;
 public:
  Genome(vector<string> s):Sites(s),Orfs(s.size()){}
  Genome(vector<string> s, vector<string> n):Sites(s,n),Orfs(s.size()){}
  //use copy_column_stx to init this as a true Sites structure
  string getup(string yn, int offset1, int offset2=-1);//inclusive
  string getup(Orf o, int offset1, int offset2=-1);
  string getup_nonfeat(string yn, int min=0, int max=INT_MAX);
  string getup_nonfeat(Orf o, int min=0, int max=INT_MAX);
  string getdown(string yn, int offset1, int offset2=-1);//inclusive
  string getdown(Orf o, int offset1, int offset2=-1);
  string getdown_nonfeat(string yn, int min=0, int max=INT_MAX);
  string getdown_nonfeat(Orf o, int min=0, int max=INT_MAX);
  string getseq(string yn);
  string getseq(Orf o);
  void pickup(istream &fin, ostream &fout, vector<string> &notfound, int min=300, int max=600);
  void pickup(istream &fin, ostream &fout, int min=300, int max=600);
  void pickdown(istream &fin, ostream &fout, vector<string> &notfound, int min=300, int max=600);
  void pickdown(istream &fin, ostream &fout, int min=300, int max=600);
  void test_start_stop(ostream &fout);
};

void pickup(int argc, char* argv[]);
void find_seqs(int argc, char *argv[]);

#endif
